      FUNCTION SPLINE ( C, H )

      DIMENSION  C(4)

      SPLINE =   C(1) + H * ( C(2) + H * ( C(3) / 2.0+
     &H * C(4) / 6.0 ))
      RETURN
      END

      FUNCTION SPLINEX ( C, H )

      DIMENSION C(4)
      SPLINEX = C(2) + H * ( C(3) + H * C(4) / 2.0 )
      RETURN
      END

      FUNCTION SPLINEXX ( C, H )

      DIMENSION C(4)

      SPLINEXX = C(3) + H * C(4)
      RETURN
      END

      SUBROUTINE ERROUT( PRTFIL, SEVRTY, WHERE, ERRMSG )

	INCLUDE "BELL99.INC"
      INTEGER PRTFIL
      CHARACTER SEVRTY *1, WHERE *(*), ERRMSG *(*)
	IF (PRTFLAG .EQ. 0) GOTO 100
      WRITE( PRTFIL, * )
      WRITE( PRTFIL, * )
      WRITE( PRTFIL, * )


      IF( SEVRTY(1:1) .EQ. 'W' ) THEN
        WRITE( PRTFIL, * ) '*** WARNING ***'
      ELSE IF( SEVRTY(1:1) .EQ. 'F' ) THEN
        WRITE( PRTFIL, * ) '*** FATAL ERROR ***'
      ELSE
        WRITE( PRTFIL, * ) '*** FATAL ERROR ***'
        WRITE( PRTFIL, * )
     *      'The error handler (ERROUT) has been called ',
     *      'with an unknown severity level: ', SEVRTY(1:1)
      ENDIF

      WRITE( PRTFIL, * )


      LAST = LEN( WHERE )
      WRITE( PRTFIL, * ) 'Find error on Program '
     +                 , ' or subroutine: ',WHERE( 1:LAST )


      LAST = LEN( ERRMSG )
      WRITE( PRTFIL, * ) ERRMSG(1:LAST)

      WRITE( PRTFIL, * )
      WRITE( PRTFIL, * )
      WRITE( PRTFIL, * )

100   CONTINUE
      IF ( SEVRTY(1:1) .EQ. 'W' ) THEN
	  RETURN
      ELSE
	  STOP 'Fatal Error: See print file for details'
      ENDIF

      RETURN
      END

      FUNCTION PICKEPS(BEAMTYP,OMEGA,C,DALPHA,RLOOP,EPMULT)

      INTEGER PRTFIL
      COMPLEX   CI,PICKEPS, EPSOPT

      CHARACTER BEAMTYP*2

      CI = ( 0.0, 1.0 ) 

      PRTFIL = PRTFIL

      IF ( BEAMTYP(1:1) .EQ. 'F' ) THEN
        WRITE( PRTFIL, * ) 'Filling beams'

	  HWIDTH = 2.0 / ( ( OMEGA / C ) * DALPHA )
	  EPSOPT = CI * 0.5 * OMEGA * HWIDTH**2

      ELSE IF ( BEAMTYP(1:1) .EQ. 'M' ) THEN

	  HWIDTH = SQRT( 2.0 * C * 1000.0 * RLOOP / OMEGA )
	  EPSOPT = CI * 0.5 * OMEGA * HWIDTH**2

      ELSE IF ( BEAMTYP(1:1) .EQ. 'W' ) THEN
	  WRITE( PRTFIL, * ) 'WKB beams'

      ELSE IF ( BEAMTYP(1:1) .EQ. 'C' ) THEN
	  WRITE( PRTFIL, * ) 'Cerveny style beam'
      ENDIF

      PICKEPS = EPMULT*EPSOPT

      RETURN
      END


