      SUBROUTINE CSPLINE (TAU, C, N, IBCBEG, IBCEND, NDIM)

      DIMENSION   TAU(500)
      DIMENSION  C(4,500)
      INTEGER L,N,M,IBCBEG,IBCEND,NDIM
      L = N - 1
      DO 10 M = 2,N
	  C(3,M) = TAU(M) - TAU(M-1)
	  C(4,M) = (C(1,M) - C(1,M-1)) / C(3,M)
   10 CONTINUE
      IF (IBCBEG.EQ.0)  THEN                            ! IBCBEG = 0
	  IF (N.GT.2)  THEN                             !     N > 2
	    C(4,1) = C(3,3)
	    C(3,1) = C(3,2) + C(3,3)
	    C(2,1) = ((C(3,2) + 2.0*C(3,1))*C(4,2)*C(3,3) + 
     +    C(3,2)**2 * C(4,3)) / C(3,1)
        ELSE                                        !     N = 2
	    C(4,1) = (1.0,0.0)
	    C(3,1) = (1.0,0.0)
	    C(2,1) = 2.0 * C(4,2)
	  END IF

      ELSE IF (IBCBEG.EQ.1)  THEN                       ! IBCBEG = 1
	  C(4,1) = (1.0,0.0)
	  C(3,1) = (0.0,0.0)

      ELSE IF (IBCBEG.EQ.2)  THEN                       ! IBCBEG = 2
	  C(4,1) = (2.0,0.0)
	  C(3,1) = (1.0,0.0)
	  C(2,1) = 3.0*C(4,2) - C(2,1)*C(3,2)/2.0
      END IF


      DO 20 M = 2,L
	  G = -C(3,M+1) / C(4,M-1)
	  C(2,M) = G*C(2,M-1) + 3.0*(C(3,M)*C(4,M+1)+
     +  C(3,M+1)*C(4,M))
	  C(4,M) = G*C(3,M-1) + 2.0*(C(3,M) + C(3,M+1))
   20 CONTINUE


      IF (IBCEND.NE.1)  THEN
	  IF (IBCEND.EQ.0)  THEN
		  IF (N.EQ.2 .AND. IBCBEG.EQ.0)  THEN
		    C(2,N) = C(4,N)
	    ELSE IF ((N.EQ.3 .AND. IBCBEG.EQ.0) .OR. N.EQ.2)  THEN
		    C(2,N) = 2.0 * C(4,N)
		    C(4,N) = (1.,0.)
		    G = -1.0 / C(4,N-1)
	    ELSE
		    G = C(3,N-1) + C(3,N)
		    C(2,N) = ((C(3,N) + 2.0*G) * C(4,N)*C(3,N-1) +
     +      C(3,N)**2 * (C(1,N-1)-C(1,N-2)) / C(3,N-1)) / G
		    G = -G / C(4,N-1)
		    C(4,N) = C(3,N-1)
	    END IF
	  ELSE IF (IBCEND.EQ.2)  THEN
	    C(2,N) = 3.0 * C(4,N) + C(2,N)*C(3,N)/2.0
	    C(4,N) = (2.0,0.0)
	    G = -1.0 / C(4,N-1)
	  END IF

	  IF ( IBCBEG.GT.0 .OR. N.GT.2)  THEN
	    C(4,N) = G*C(3,N-1) + C(4,N)
	    C(2,N) = (G*C(2,N-1) + C(2,N)) / C(4,N)
	  END IF
      END IF


      DO 40 J = L,1,-1
	  C(2,J) = (C(2,J) - C(3,J)*C(2,J+1)) / C(4,J)
   40 CONTINUE


      DO 50 I = 2,N
	  DTAU = C(3,I)
	  DIVDF1 = (C(1,I)-C(1,I-1)) / DTAU
	  DIVDF3 = C(2,I-1) + C(2,I) - 2.0*DIVDF1
	  C(3,I-1) = 2.0 * (DIVDF1-C(2,I-1)-DIVDF3) / DTAU
	  C(4,I-1) = (DIVDF3/DTAU) * (6.0/DTAU)
   50 CONTINUE


      C(3,N) = C(3,L) + (TAU(N)-TAU(L)) * C(4,L)



      C(4,N) = (0.0,0.0)
      DO 60 I = 1,L                             ! INTEGRATE OVER THE INTERVAL
	  DTAU = TAU(I+1) - TAU(I)
	  C(4,N) = C(4,N) + DTAU*(C(1,I) + DTAU*(C(2,I)/2.0 + 
     +  DTAU*(C(3,I)/6.0 + DTAU*C(4,I)/24.0)))
   60 CONTINUE
      C(4,N) = C(4,N) / (TAU(N)-TAU(1))         ! DIVIDE BY LENGTH OF INTERVAL

      RETURN
      END

      SUBROUTINE SPLINEALL ( C, H, F, FX, FXX )


      PARAMETER ( HALF = 0.5, SIXTH = 1.0 / 6.0 )

      DIMENSION C(4)

      F   = C(1) + H * ( C(2) + H * ( HALF * C(3) + SIXTH * H * C(4) ))
      FX  = C(2) + H * ( C(3) + H * HALF * C(4) )
      FXX = C(3) + H * C(4)

      RETURN
      END

      SUBROUTINE VSPLINE (TAU, C, M, MDIM, F, N)

      DIMENSION TAU(M),F(N)
      INTEGER I,J,N,M,MDIM

      MDIM = MDIM
      J = 1
      DO 20 I = 1,N
   10   J1 = J + 1
        IF (TAU(J1).LT.REAL(F(I)) .AND. J1.LT.M) THEN ! CHECK TO MAKE SURE
	    J = J + 1                                  ! THIS POINT IS NOT
	    GO TO 10                                   ! IN THE NEXT INTERVAL.
        END IF
        H = DBLE (F(I)) - TAU(J)                  ! DISTANCE FROM START OF INTERVAL
        F(I) = SPLINE (C(1,J), H)
   20 CONTINUE
      RETURN
      END
